#! /usr/bin/python 

#current db module, need to figure out an easier way to change this
#imported as dbm to make refereces db indepentent
from pysqlite2 import dbapi2 as dbm
#import psycopg2 as dbm
from datetime import datetime
#import calendar

#used to make sure sqlite database exisits to aviod creating blank ones
from os.path import isfile

#my stuff for xml and http
from atomxml import atomxml
from http import http

class atomdb:
	
	def connect(self, user = "atom", pwd = "securepass", host = "localhost", \
			database = "atomdb"):

		#for postgres
		#db = dbm.connect(database=database, user=user, password=pwd)
		#for sqlite
		database = "atomdb.sq3"
		db = dbm.connect(database=database, detect_types=dbm.PARSE_DECLTYPES|dbm.PARSE_COLNAMES)

		return db

	def close(self, cons):
		for con in cons:
			con.close()

	#convert from RFC-3339 date strings to form pysqlite likes
	#assumes date is in RFC-3339 utc format
	def convertDates(self, date):
		date = date[:-1]
		date = date.replace("T", " ", 1)
		return date

	def insert(self, entry):
		#date stuff may be sqlite specific

		#parse the input into its elements, must be xml
		elements = atomxml().parseentry(entry)
		


		#if published does not exist use updated
		#this should only be done for new inserts
		if not elements["entry"].has_key("published"):
			elements["entry"]["published"] = elements["entry"]["updated"]

		#convert dates
		elements["entry"]["published"] = self.convertDates(elements["entry"]["published"])
		elements["entry"]["updated"] = self.convertDates(elements["entry"]["updated"])
		
		db = self.connect(user="postgres", pwd="postgres")
		#db = self.connect()
		if not db:
			return None
		cur = db.cursor()

		#lookup authors
		authors = []
		for author in elements["authors"]:
			#cur.execute("SELECT akey FROM authors WHERE name LIKE %(name)s;", author)
			cur.execute("SELECT akey FROM authors WHERE name LIKE :name;", author)
			res = cur.fetchone()
			if not res:
				res = self.inauthor(cur, author)
			else:
				res = res[0]

			authors.append(res)

		#lookup contributers
		contributers = []
		for contributer in elements["contributers"]:
			cur.execute("SELECT akey FROM authors WHERE name LIKE :name;", contributer)
			res = cur.fetchone()
			if not res:
				res = self.inauthor(cur, contributer)
			else:
				res = res[0]

			contributers.append(res)

		#lookup categories
		#needs to handle multiple 
		categories = []
		for category in elements["categories"]:
			#cur.execute("SELECT ckey FROM categories WHERE category LIKE %s;", (category,))
			cur.execute("SELECT ckey FROM categories WHERE category LIKE ?;", (category,))
			res = cur.fetchone()
			if not res:
				res = self.incat(cur, category)

			categories.append(res[0])

		#inentry (handles authorxentry, etc.)
		#I think there is a count sql can do for me
		#cur.execute("SELECT ekey FROM entries where published >= date(%(published)s) AND published < (date(%(published)s) + interval '1 day');", elements["entry"])
		cur.execute("SELECT ekey FROM entries where published >= date(:published) AND published < (date(:published, '+1 day'));", elements["entry"])
		num = len(cur.fetchall()) + 1
		date = elements["entry"]["published"][:10]
		date = date.replace("-", "")
		id = date+"-"+str(num)
		elements["entry"]["link"] = "http://physcofish.com/entry.php?id="+id
		elements["entry"]["id"] = id
		entry = self.inentry(cur, elements["entry"], authors, contributers, categories)

		#write the changes and close the connection
		db.commit()
		self.close([cur,db])

		return None
	
	def find(self, id):
		#need to check for goodness
		#id = self.cleaninput(id)
		db = self.connect()
		if not db:
			return None
		cur = db.cursor()
		#cur.execute("SELECT ekey FROM entries WHERE id = %s;", (id,))
		cur.execute("SELECT ekey FROM entries WHERE id = ?;", (id,))

		if cur.rowcount == 0:
			self.close([cur,db])
			return None
		results = cur.fetchall()
		
		#close db stuff
		self.close([cur,db])

		return results

	def remove(self):
		return None

	def edit(self):
		return None

	#need to check input to make sure it is good
	def getentry(self, id):
		#id = self.cleaninput(str(id))
		db = self.connect()
		if not db:
			return None
		cur = db.cursor()
		
		#entry
		#cur.execute("SELECT * FROM entries where ekey = %s;", (id,))
		cur.execute("SELECT * FROM entries where ekey = ?;", (id,))
		if cur.rowcount == 0:
			self.close([cur,db])
			return None
		tmp = cur.fetchall()[0]
		entry = []
		for i in range(0,len(tmp)):
			entry.append(tmp[i])

		#convert sqlite date strings to date objects
		#tmp = entry[5].split(" ")
		#date = tmp[0].split("-")
		#time = tmp[1].split(":")
		#entry[5] = datetime(int(date[0]), int(date[1]), int(date[2]), int(time[0]), int(time[1]), int(time[2]))
		#entry[5] = calendar.timegm((int(date[0]), int(date[1]), int(date[2]), int(time[0]), int(time[1]), int(time[2])))
		
		#tmp = entry[6].split(" ")
		#date = tmp[0].split("-")
		#time = tmp[1].split(":")
		#entry[6] = datetime(int(date[0]), int(date[1]), int(date[2]), int(time[0]), int(time[1]), int(time[2]))
		#entry[6] = calendar.timegm((int(date[0]), int(date[1]), int(date[2]), int(time[0]), int(time[1]), int(time[2])))

		#authors
		#cur.execute("SELECT authors.*  FROM authorxentry LEFT JOIN authors ON authorxentry.authorid = authors.akey WHERE entryid = %s;", (entry[0],))
		cur.execute("SELECT authors.*  FROM authorxentry LEFT JOIN authors ON authorxentry.authorid = authors.akey WHERE entryid = ?;", (entry[0],))
		authors = cur.fetchall()
		
		#contributers
		#cur.execute("SELECT authors.*  FROM contribxentry LEFT JOIN authors ON contribxentry.contribid = authors.akey WHERE entryid = %s;", (entry[0],))
		cur.execute("SELECT authors.*  FROM contribxentry LEFT JOIN authors ON contribxentry.contribid = authors.akey WHERE entryid = ?;", (entry[0],))
		contributers = cur.fetchall()
		
		#categories
		#cur.execute("SELECT categories.*  FROM categoryxentry LEFT JOIN categories ON categoryxentry.categoryid = categories.ckey WHERE entryid = %s;", (entry[0],))
		cur.execute("SELECT categories.category  FROM categoryxentry LEFT JOIN categories ON categoryxentry.categoryid = categories.ckey WHERE entryid = ?;", (entry[0],))
		categories = cur.fetchall()
		#clean out the tuples
		for i in range(len(categories)):
			categories[i] = categories[i][0]
			

		#close db stuff
		self.close([cur,db])
		
		#return a list of all elements
		return [entry, authors, contributers, categories]

	def getlatest(self, num = 10, update = 1):
		#make sure num is a number
		if type(num) != type(1):
			return None

		db = self.connect()
		if not db:
			return None
		cur = db.cursor()

		if update == 1:
			#cur.execute("SELECT ekey FROM entries ORDER BY updated LIMIT %s;", (num,))
			cur.execute("SELECT ekey FROM entries ORDER BY updated LIMIT ?;", (num,))
		else:
			#cur.execute("SELECT ekey FROM entries ORDER BY published LIMIT %s;", (num,))
			cur.execute("SELECT ekey FROM entries ORDER BY published LIMIT ?;", (num,))

		results = cur.fetchall()

		#close db stuff
		self.close([cur,db])

		return results

	def inauthor(self, cur, author):
		#cur.execute("INSERT INTO authors VALUES(DEFAULT, %(name)s, 'Nick', %(email)s, %(uri)s, 'Passhash');", author)
		cur.execute("INSERT INTO authors VALUES(NULL, :name, 'Nick', :email, :uri, 'Passhash');", author)
		#cur.execute("SELECT akey FROM authors WHERE name = %(name)s;", author)
		cur.execute("SELECT akey FROM authors WHERE name = :name;", author)
		res = cur.fetchone()
		return res[0]

	def incat(self, cur, cat):
		#cur.execute("INSERT INTO categories VALUES(DEFAULT, %s);", (cat,))
		cur.execute("INSERT INTO categories VALUES(NULL, ?);", (cat,))
		#cur.execute("SELECT ckey FROM categories WHERE category = %s;", (cat,))
		cur.execute("SELECT ckey FROM categories WHERE category = ?;", (cat,))
		res = cur.fetchone()
		return res[0]

	def inentry(self, cur, entry, authors, contributers, categories):
		#cur.execute("INSERT INTO entries VALUES(DEFAULT, %(title)s, %(subtitle)s, %(link)s, %(id)s, %(published)s, %(updated)s, %(summary)s, %(content)s, %(rights)s, %(ctype)s, %(src)s);", entry)
		cur.execute("INSERT INTO entries VALUES(NULL, :title, :subtitle, :link, :id, :published, :updated, :summary, :content, :rights, :ctype, :src);", entry)
		#cur.execute("SELECT ekey FROM entries WHERE id = %(id)s;", entry)
		cur.execute("SELECT ekey FROM entries WHERE id = :id;", entry)
		res = cur.fetchone()
		res = res[0]

		for author in authors:
			#cur.execute("INSERT INTO authorxentry VALUES(%s, %s);", (author, res,))
			cur.execute("INSERT INTO authorxentry VALUES(?, ?);", (author, res,))

		for contributer in contributers:
			#cur.execute("INSERT INTO contributerxentry VALUES(%s, %s);", (contributer, res,))
			cur.execute("INSERT INTO contributerxentry VALUES(?, ?);", (contributer, res,))

		for category in categories:
			#cur.execute("INSERT INTO categoryxentry VALUES(%s, %s);", (category, res,))
			cur.execute("INSERT INTO categoryxentry VALUES(?, ?);", (category, res,))

if __name__ == '__main__':
	pass
	#testa = atomdb()
	#testa.find("tmp")
