--CREATE DATABASE atomdb;
--GRANT SELECT ON atomdb.* TO 'atom'@'localhost' IDENTIFIED BY 'securepass';
--GRANT SELECT INSERT DELETE UPDATE ON atomdb.* TO 'masteratom'@'localhost' IDENTIFIED BY 'wH4tPa5s';
--USE atomdb;
CREATE TABLE entries(
	ekey SERIAL UNIQUE primary key,
	title VARCHAR(255),
	subtitle VARCHAR(255),
	link VARCHAR(255),
	id VARCHAR(255),
	published TIMESTAMP,
	updated TIMESTAMP,
	summary VARCHAR(255),
	content TEXT,
	rights VARCHAR(255),
	ctype VARCHAR(25),
	src VARCHAR(255)
);
CREATE TABLE authors(
	akey SERIAL UNIQUE primary key,
	name VARCHAR(255),
	nick VARCHAR(255) UNIQUE,
	email VARCHAR(255),
	uri VARCHAR(255),
	passhash VARCHAR(255)
);
CREATE TABLE categories(
	ckey SERIAL UNIQUE primary key,
	category VARCHAR(255)
);
CREATE TABLE authorxentry(
	authorid INTEGER REFERENCES authors (akey),
	entryid INTEGER REFERENCES entries (ekey)
);
CREATE TABLE contribxentry(
	contribid INTEGER REFERENCES authors (akey),
	entryid INTEGER REFERENCES entries (ekey)
);
CREATE TABLE categoryxentry(
	categoryid INTEGER REFERENCES categories (ckey),
	entryid INTEGER REFERENCES entries (ekey)
);
