#! /usr/bin/python
from datetime import datetime
from atomdb import atomdb
from atomxml import atomxml

class atomfeed:
	db = atomdb()

	def regenfeed(self):
		#open the atom.xml file
		#should probably use locking sometime to do this
		feed = open("atom.xml", "w")

		#add in the xml declaration
		feed.write("<?xml version=\"1.0\" encoding=\"utf-8\"?>\n")
		feed.write("<feed xmlns=\"http://www.w3.org/2005/Atom\" xml:lang=\"en-US\">\n")

		#add in the feed header stuff
		feed.write("<title>Physcofish.com</title>\n")
		feed.write("<subtitle>Jon's Atom Feed</subtitle>\n")
		feed.write("<link href=\"http://physcofish.com/atom.xml\" rel=\"self\" />\n")
		feed.write("<link href=\"http://physcofish.com/cgi-bin/pfatom.py/feed\" rel=\"alternate\" title=\"Physcofish.com\" type=\"text/html\" />\n")
		feed.write("<id>http://physcofish.com/</id>\n")
		feed.write("<updated>"+datetime.utcnow().strftime("%Y-%m-%dT%H:%M:%SZ")+"</updated>\n")
		feed.write("<author>\n<name>Jon Klimowicz</name>\n</author>\n")
		feed.write("<generator>pfatom</generator>\n")
		#feed.write("")
		#feed.write("")
		
		results = self.db.getlatest()

		#get authors, contributers, and categories
		#then pass to xml
		for id in results:
			entry = self.db.getentry(id[0])
			if not entry:
				feed.write("<entry>\nError: story not found\n</entry>")
				break
			
			#call atomxml
			feed.write(atomxml().feedentry(entry[0], entry[1], entry[2], entry[3]))
		
		#print the end of the file and close it
		feed.write("</feed>")
		feed.close()

	def insert(self, elements, authors, contributers, categories):
		pass

	def remove(self, id):
		pass
	
	def getfeed(self, type="all"):
		#print "Content-Type: text/xml\n"
		try:
			feed = open("atom.xml", "r")
		except IOError:
			self.regenfeed()
			try:
				feed = open("atom.xml", "r")
			except IOError:
				return None
				
		print "Content-Type: text/xml\n"
		line = feed.read()
		print line
		feed.close()

if __name__ == '__main__':
	pass
	#test = atomfeed()
	#test.regenfeed()
