#! /usr/bin/python
from pysqlite2 import dbapi2 as sqlite

#create the db
#this will open an already existing db also so be careful
db = sqlite.connect("atomdb.sq3")
#create a cursor
cur = db.cursor()

#create the tables
cur.execute("CREATE TABLE entries(ekey INTEGER NOT NULL, title VARCHAR(255), subtitle VARCHAR(255), link VARCHAR(255), id VARCHAR(255), published TIMESTAMP, updated TIMESTAMP, summary VARCHAR(255), content TEXT, rights VARCHAR(255), ctype VARCHAR(20), src VARCHAR(255), PRIMARY KEY(ekey));")

#manually must make sure nick is unique
cur.execute("CREATE TABLE authors(akey INTEGER NOT NULL, name VARCHAR(255), nick VARCHAR(255), email VARCHAR(255), uri VARCHAR(255), passhash VARCHAR(255), PRIMARY KEY(akey));")

cur.execute("CREATE TABLE categories(ckey INTEGER NOT NULL, category VARCHAR(255), PRIMARY KEY(ckey));")

cur.execute("CREATE TABLE authorxentry(authorid INTEGER, entryid INTEGER);")
#cur.execute("CREATE TABLE authorxentry(authorid INTEGER, entryid INTEGER, PRIMARY KEY(authorid, entryid));")

cur.execute("CREATE TABLE contribxentry(contribid INTEGER, entryid INTEGER);")
#cur.execute("CREATE TABLE contribxentry(contribid INTEGER, entryid INTEGER, PRIMARY KEY(contribid, entryid));")

cur.execute("CREATE TABLE categoryxentry(categoryid INTEGER, entryid INTEGER);")
#cur.execute("CREATE TABLE categoryxentry(categoryid INTEGER, entryid INTEGER, PRIMARY KEY(categoryid, entryid));")

db.commit()
